<template>
  <component
    v-on:mounted="componentPropertySetup"
    class="vlue-content-component"
    :class="getProps(pathway.folder, pathway.name).cssClass"
    :props="getProps(pathway.folder, pathway.name)"
    :is="getContentComponent(pathway.folder, pathway.name)">
  </component>
</template>

<script lang="ts">
import Vue from 'vue'
import store from '../../store/store'
import { mapState } from 'vuex'

export default Vue.extend({
  computed: {
    ...mapState([
      'website',
      'contentComponentProps',
    ]),
  },
  props: {
    pathway: Object,
    props: Object,
  },
  methods: {
    getProps(folder, name) {
      // return props with priority instance > global > default
      return {
        // default
        ...Object.keys(this.contentComponentProps[folder]?.[name] ?? {}).reduce((acc, key) => (
          { ...acc, [key]: this.contentComponentProps[folder][name][key].default }
        ), {}),
        // global
        ...this.website.globalComponentPropValues[folder]?.[name],
        // instance
        ...this.props,
      };
    },
    getContentComponent(folder, name) {
      return require('../content/' + folder + '/' + name + '.vue').default;
    },
    componentPropertySetup(props) {
      // add props available to all content components
      props.push({
        name: 'cssClass',
        type: 'textfield',
        value: '',
      });
      // store props in state
      store.commit('componentPropertySetup', {
        pathway: this.pathway,
        props,
      });
    },
  },
})
</script>

<style lang="scss">
.vlue-content-component {
  position: relative;
}
</style>
